'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var prefix = '@@reactReduxFirebase/';

var defaultJWTKeys = exports.defaultJWTKeys = ['aud', 'auth_time', 'exp', 'firebase', 'iat', 'iss', 'sub', 'user_id'];

var actionTypes = exports.actionTypes = {
  START: prefix + 'START',
  SET: prefix + 'SET',
  SET_PROFILE: prefix + 'SET_PROFILE',
  LOGIN: prefix + 'LOGIN',
  LOGOUT: prefix + 'LOGOUT',
  LOGIN_ERROR: prefix + 'LOGIN_ERROR',
  NO_VALUE: prefix + 'NO_VALUE',
  UNAUTHORIZED_ERROR: prefix + 'UNAUTHORIZED_ERROR',
  INIT_BY_PATH: prefix + 'INIT_BY_PATH',
  AUTHENTICATION_INIT_STARTED: prefix + 'AUTHENTICATION_INIT_STARTED',
  AUTHENTICATION_INIT_FINISHED: prefix + 'AUTHENTICATION_INIT_FINISHED'
};

exports.default = _extends({
  defaultJWTKeys: defaultJWTKeys
}, actionTypes);


module.exports = _extends({
  defaultJWTKeys: defaultJWTKeys
}, actionTypes);